import React, { Component } from 'react';
require('./index.scss');

export default class extends Component {
  constructor(props) {
    super(props);
    // this.handlebutton = this.handlebutton.bind(this);
    this.onArrowClick = this.onArrowClick.bind(this);

    //鼠标hover时出现删除操作
    // this.addFalse = this.addFalse.bind(this);
    // this.cancalFalse = this.cancalFalse.bind(this);

    // //鼠标点击hover时删除
    // this.clickFork = this.clickFork.bind(this);
    this.state = {
      dataSource: this.props.dataSource
    };
  }

  componentDidMount() {
    setTimeout(() => {
      const activeLeft = this.activeBtn.offsetLeft;

      //一页的长度
      const pageLen = this.contentDom.offsetWidth;

      //可以滚动的距离
      const distances = this.scrollDom.offsetWidth - pageLen;

      //可以滚动的总页数
      const pages = Math.abs(distances / pageLen);

      //当前页数
      const page = activeLeft / pageLen;


      if (pages <= 1) {
        document.getElementsByClassName('arrow left')[0].style.display = 'none';
        document.getElementsByClassName('arrow right')[0].style.display = 'none';
      }
      if (distances > 0) {
        this.scrollDom.className = 'scroll-content leftalign';
      }
      if (activeLeft > pageLen) {
        this.scrollDom.style.left = `-${(page + 1) >= pages ? Math.abs(distances) : (page + 1) * pageLen}px`;
      }
    }, 500)
  }


  addFalse = (index) => (event) => {
    if (!this.props.closeIcon) return
    if (this.state.dataSource.length != 1) {
      //hover中的selectButton
      var hoverButton = document.getElementsByClassName('selectbuttton_false');
      hoverButton[index].style.opacity = 1;
    }

  }

  componentWillReceiveProps(nextProps) {
    this.setState({ 'dataSource': nextProps.dataSource })
  }

  clickFork = (index) => (e) => {

    //在react中阻止默认事件与冒泡不能直接使用stopPropagation，preventDefault
    e.nativeEvent.stopPropagation()
    e.preventDefault();

    //dataFork为事件抛出函数
    if (this.props.clickCloselcon) {
      this.props.clickCloselcon(index, this.state.dataSource[index]);
    }


  }
  aClick = (index) => (e) => {

    if (this.props.cancel) {
      e.preventDefault();
      if (this.props.fickClick) {
        this.props.fickClick(this.state.dataSource[index]);
      }
      return;
    }
  }
  cancalFalse = (index) => (event) => {
    if (!this.props.closeIcon) return
    //hover中的selectButton
    var hoverButton = document.getElementsByClassName('selectbuttton_false')[index];
    hoverButton.style.opacity = 0;
  }

  handlebutton(point) {
    this.state.dataSource.forEach((data, index) => {
      data[this.props.activeFieldName] = (point === index ? true : false);
    });
    this.setState({ dataSource: this.state.dataSource });
    this.props.stateChange ? this.props.stateChange(this.props.dataSource[key]) : null;
  }
  /**
  * 滚动按钮点击事件：点击一次滚动一页，不够一页滚动剩余部分
  */
  onArrowClick(e) {
    if (this.distances <= 0) {
      return;
    }
    //可以滚动的距离
    this.distances = this.scrollDom.offsetWidth - this.contentDom.offsetWidth;
    //可以滚动的总页数
    this.pages = Math.abs(this.distances / this.contentDom.offsetWidth);
    //一页的长度
    this.pageLen = this.contentDom.offsetWidth;

    if (this.distances <= 0) {
      this.refs.arrowL.style.visibility = 'hidden';
      this.refs.arrowR.style.visibility = 'hidden';
    }
    //是否点击右侧按钮
    const isRight = e.target && e.target.className.match('right');
    //需要滚动元素left值
    const domLeft = Math.abs(parseInt(this.scrollDom.style.left || 0));
    //当前页数
    const page = domLeft / this.contentDom.offsetWidth;

    this.scrollDom.style.left = '-' + (isRight ? ((page + 1) >= this.pages ? Math.abs(this.distances) : (page + 1) * this.pageLen) : page - 1 <= 0 ? 0 : (page - 1) * this.pageLen) + 'px';
  }

  render() {
    return (
      <div className="selectbuttontop-container">
        <div className='arrow left' ref='arrowL' onClick={this.onArrowClick} />
        <div className='content' ref={content => { this.contentDom = content }}>
          <div className='scroll-content' ref={scroll => { this.scrollDom = scroll }}>
            {
              this.state.dataSource.map((ele, index) => {
                if (ele.disable) {
                  return (
                    <div>
                      <a
                        tabIndex={index}
                        key={index}
                        className={`${ele[this.props.activeFieldName] && 'active'} disable`}
                        ref={activeBtn => { if (ele[this.props.activeFieldName]) { this.activeBtn = activeBtn }; if (this.state.dataSource.length - 1 === index) { this.lastBtn = activeBtn } }}
                      >
                        <span className='disable_zi'> {ele[this.props.fieldName]}</span>
                      </a>
                      {
                        this.props.closeIcon &&
                        <span className='selectbuttton_false' onClick={this.clickFork(index)}
                        ></span>
                      }
                    </div>
                  )
                }
                else return (
                  <div>
                    <a href={ele[this.props.linkFieldName]}
                      tabIndex={index}
                      key={index}
                      onClick={this.aClick(index)}
                      onMouseEnter={this.addFalse(index)}
                      onMouseLeave={this.cancalFalse(index)}
                      className={`${ele[this.props.activeFieldName] && 'active'} default`}
                      ref={activeBtn => { if (ele[this.props.activeFieldName]) { this.activeBtn = activeBtn }; if (this.state.dataSource.length - 1 === index) { this.lastBtn = activeBtn } }}
                    >
                      {ele[this.props.fieldName]}
                    </a>
                    {
                      this.props.closeIcon &&
                      <span className='selectbuttton_false' onClick={this.clickFork(index)}
                        onMouseEnter={this.addFalse(index)}
                        onMouseLeave={this.cancalFalse(index)}
                      ></span>
                    }
                  </div>
                )
              })
            }
          </div>
        </div>
        <div className='arrow right' ref='arrowR' onClick={this.onArrowClick} />
      </div>
    )
  }
}
